export type Vector2 = [number, number];
export type OrdinalDirection = "NORTH" | "SOUTH" | "EAST" | "WEST";
export type CodeBoxOptions = {
    /**
     * The function to pipe the output of the CodeBox to
     */
    outputCallback?: Function,
    /**
     * An amount of seconds to sleep between the execution of instuctions in the CodeBox
     */
    tickSleep?: number,
    /**
     * Options for debugging the CodeBox
     */
    debug?: {
        /**
         * Options for printing parts of the interpreter
         */
        print?: {
            /**
             * The function used to log the debug calls of the CodeBox
             */
            logger?: Function,
            /**
             * If true, the CodeBox will be printed after each movement of the
             * InstructionPointer.
             */
            codeBox?: boolean,
            /**
             * If true, the values of all stacks will be printed after each
             * movement of the InstructionPointer.
             */
            stacks?: boolean,
        }
    },
};